export function relation() 
{
    var a, b, c, d, e, f = "id",
    g = 15,
    h = 500,
    i = 960,
    j = -30,
    k = 20,
    l = 2;
  
  this.setNodes = function(b) {
    a = b;
  };
  this.setLinks = function(a) {
    b = a;
  };
  this.setCanvas = function(a) {
    d = a;
  };
  this.setRadius = function(a) {
    g = a;
  };
  
  this.setSize = function(a, b) {
    h = a;
    i = b;
  };
  this.setLinkLength = function(a) {
    k = a;
  };
  this.setCharge = function(a) {
    j = a;
  };
    
  this.init = function() {
    e = d.getContext('2d');

    c = d3.forceSimulation()
      .force("charge", 
             d3.forceManyBody()
             .strength(j))
      .force("center", 
             d3.forceCenter(h / 2, i / 2))
      .force("collide", 
             d3.forceCollide(1.2 * g));
		console.log(c);
    c.nodes(a)
      .on("tick", this.render);

    c.force("link", d3.forceLink()
              .links(b)
              .id(function(a) {
        return a[f]
    })
              .distance(k))
      
    this.initDrag();
    this.restart();
    this.pause();
  };
  
  this.render = function() {
    e.clearRect(0, 0, h, i),
      e.lineWidth = 1, 
      e.strokeStyle = "rgb(214,214,214)",
      e.beginPath(), 
    b.forEach(function(a) {
        e.moveTo(a.source.x, a.source.y),
        e.lineTo(a.target.x, a.target.y)
    }),
      e.stroke(), 
      e.lineWidth = 2, 
      e.strokeStyle = "white", 
      a.forEach(function(a) {
        e.fillStyle = a.color, 
          e.beginPath(), 
          e.arc(a.x, a.y, a.radius, 0, 2 * Math.PI), 
          e.fill(), 
          e.stroke()
    })
  };
     
  this.initDrag = function() {
    function a() {
        return c.find(d3.event.x, d3.event.y)
    }
    function b() {
      d3.event.active || c.alphaTarget(.3).restart()
      d3.event.subject.fx = d3.event.subject.x
      d3.event.subject.fy = d3.event.subject.y
    }

    function e() {
        d3.event.subject.fx = d3.event.x, d3.event.subject.fy = d3.event.y
    }

    function f() {
        d3.event.active || c.alphaTarget(0), d3.event.subject.fx = null, d3.event.subject.fy = null
    }
    d3.select(d).call(d3.drag().container(d).subject(a).on("start", b).on("drag", e).on("end", f))
  };
        
  this.pause = function() {
    c.stop();
  }; 
        
  this.run = function() {
    c.restart();
  };
  this.restart = function() {
    c.alpha(1);
    this.run();
  };
}